//
//  MembershipListViewController.swift
//  SuperSpaManagement
//
//  Created by PHAM ANH TUAN on 3/21/21.
//  Copyright (c) 2021 ___ORGANIZATIONNAME___. All rights reserved.
//
//  This file was generated by the 🐍 VIPER generator
//

import UIKit
import RxSwift
import RxCocoa
import RxDataSources

protocol MembershipListPresenterInterface: PresenterInterface {
    var addMembershipTrigger: PublishRelay<Void> { get }
    var selectedModelTrigger: PublishRelay<Membership> { get }
    var viewWillAppearTrigger: BehaviorRelay<Bool> { get }
}

final class MembershipListViewController: UIViewController, MembershipListViewInterface {
    
    @IBOutlet weak var tableView: UITableView!
    
    // MARK: - Public properties -
    
    let viewModels = BehaviorRelay<[MembershipItemViewModel]>(value: [])
    var presenter: MembershipListPresenterInterface!
    // MARK: - Internal properties -
    private lazy var dataSource = makeDataSource()
    private let viewDidLoadRelay = BehaviorRelay(value: false)
    private let disposeBag = DisposeBag()
    
    // MARK: - Lifecycle -
    
    override func viewDidLoad() {
        super.viewDidLoad()
        defer {
            viewDidLoadRelay.accept(true)
        }
        configureViews()
        configurePresenter()
    }
    
    override func viewWillAppear(_ animated: Bool) {
        super.viewWillAppear(animated)
        defer {
            presenter.viewWillAppearTrigger.accept(true)
        }
        setupNavigation()
    }
    
    
}

// MARK: - Extensions -

extension MembershipListViewController {
    private func setupNavigation() {
        navigationItem.title = "Danh sách thành viên"
        
        navigationItem.rightBarButtonItem = UIBarButtonItem(
            title: "Thêm",
            style: .plain,
            target: self,
            action: #selector(didTapAddMemebershipBarButton)
        )
    }
    
    @objc func didTapAddMemebershipBarButton() {
        presenter.addMembershipTrigger.accept(())
    }
}

extension MembershipListViewController {
    private func configureViews() {
        configureTableView()
    }
    
    private func configureTableView() {
        tableView.register(cellType: MembershipItemCell.self)
        
        tableView
            .rx
            .modelSelected(MembershipItemViewModel.self)
            .map { $0.model }
            .bind(to: presenter.selectedModelTrigger)
            .disposed(by: disposeBag)
    }
}

extension MembershipListViewController {
    private func configurePresenter() {
        let didLoad = viewDidLoadRelay.asObservable()
        viewModels
            .filterEmpty()
            .distinctUntilChanged()
            .takeLatestWhen(didLoad)
            .map { [ Section(model: 0, items: $0)] }
            .asDriver(onErrorDriveWith: .never())
            .drive(tableView.rx.items(dataSource: dataSource))
            .disposed(by: disposeBag)
    }
}

extension MembershipListViewController {
    typealias Section = AnimatableSectionModel<Int, MembershipItemViewModel>
    typealias DataSource = RxTableViewSectionedAnimatedDataSource<Section>
}

extension MembershipListViewController {
    private func makeDataSource() -> DataSource {
        return DataSource(
            animationConfiguration: AnimationConfiguration(
                insertAnimation: .none,
                reloadAnimation: .none,
                deleteAnimation: .none
            )
        ){ (_, tableView, indexPath, viewModel) -> UITableViewCell in
            let cell: MembershipItemCell = tableView.dequeueReusableCell(for: indexPath)
            cell.configureCell(viewModel: viewModel)
            return cell
        }
    }
}
